#include<bits/stdc++.h>
using namespace std;

const int maxn=1000003;
int n;
unsigned long long ans=0;
stack <int> t[maxn];
int teglo[maxn];

int main(){
cin>>n;
teglo[0]=0;
for(int i=1; i<=n; i++){
    int p, m;
    cin>>p>>m;
    int curr_t;
    if(m==0){
        t[i]=t[p];
        t[i].pop();
        teglo[i]=teglo[p]-t[p].top();
    }else{
        t[i]=t[p];
        t[i].push(m);
        teglo[i]=teglo[p]+m;
    }
    ans+=teglo[i];
}
cout<<ans;
return 0;
}
